<template>
  <el-button
    :class="{
      'stateful-button': true,
      ['state-' + (internalState || 'inactive')]: true,
    }"
    :disabled="disabled"
    @click="onClick($event)"
  >
    <slot v-if="!internalState"></slot>
    <span v-else-if="internalState == 'error'">
      {{ error }}
    </span>
    <span v-else>
      <loading-dots class="loading" />
    </span>
  </el-button>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";

.stateful-button {
  @include button;

  &:active {
    opacity: 0.75;
  }
}

span {
  display: inline-block;
}

.stateful-button.state-error {
  color: $color-error-text;
  font-weight: 400;
  background-color: $color-error;
}

.loading {
  margin: auto;
}

*:focus {
  outline: none;
}
</style>
<script>
import { pause } from "~/lib/utils";

export const EVENT_CLICK = "click";

export default {
  props: {
    state: { type: String, required: false },
    disabled: { type: Boolean, default: false },
    buttonStyle: { type: String, required: false, default: "normal" },
    // the click prop allows you to assign a function that can
    // actually return information.  If you assign it a function that
    // returns a promise, the state of the button will track the state
    // of the promise.
    click: {
      type: Function,
      required: false,
    },
  },
  data() {
    return { internalState: this.state, currentPromise: null };
  },
  watch: {
    state() {
      this.internalState = this.state;
    },
  },
  methods: {
    async onClick(event) {
      if (this.currentPromise) return;

      const cb = this.click || this.$listeners.click;

      if (cb) {
        this.internalState = "loading";
        // if there's an error, display the error in-line for 4
        // seconds, then go back to neutral state:
        try {
          this.currentPromise = cb(event);
          var res = await this.currentPromise;
        } catch (x) {
          if (typeof this.$report == "function") {
            this.$report(x);
          }

          this.internalState = "error";
          this.error = x.message || x.error || x;

          await pause(4000);
        }

        this.currentPromise = null;
        this.error = null;
        this.internalState = null;
      } else {
        this.$emit(EVENT_CLICK, event);
      }
    },
  },
};
</script>
